var imgbot =
{
	open:
	function(event)
	{
		if (event.target.id)
		{
			var open_float = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("imgbot.overlay.open_float").getBoolPref("");
			if (event.button == 1)
			{
				open_float = !open_float;
			}
			if (open_float)
			{
				this.openFloat();
			}else{
				this.openTab();
			}
		}
	},
	openTab:
	function(handler)
	{
		if (!this.getInstance())
		{
			var tab = gBrowser.addTab("chrome://imgbot/content/tabs.xul");
			gBrowser.selectedTab = tab;
			if (handler)
			{
				gBrowser.getBrowserForTab(tab).webProgress.addProgressListener(
				{
					onStateChange:
					function(webProgress, request, stateFlags, status)
					{
						if (stateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP)
						{
							webProgress.removeProgressListener(this);
							handler(webProgress.DOMWindow.wrappedJSObject);
						}
					},
					QueryInterface:
					function()
					{
						return this;
					}
				}, Components.interfaces.nsIWebProgress.NOTIFY_STATE_NETWORK);
			}
		}
	},
	openFloat:
	function(handler)
	{
		if (!this.getInstance())
		{
			var win = open("chrome://imgbot/content/tabs.xul", "imgbot", "chrome, resizable");
			if (handler)
			{
				win.addEventListener("load",
				function()
				{
					win.removeEventListener("load", arguments.callee, false);
					handler(win);
				}, false);
			}
		}
	},
	getInstance:
	function()
	{
		var
		nsIWindowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator),
		win = nsIWindowMediator.getMostRecentWindow("imgbot");
		if (win)
		{
			win.focus();
			return win;
		}
		var browser_wins = nsIWindowMediator.getEnumerator("navigator:browser");
		while (browser_wins.hasMoreElements())
		{
			win = browser_wins.getNext();
			for (var i = 0; i < win.gBrowser.browsers.length; ++i)
			{
				var win2 = win.gBrowser.browsers[i].contentWindow.wrappedJSObject;
				if (win2.IMGBOT_xleroe452f7iatiugles1uBroe6iublU)
				{
					win.focus();
					win.gBrowser.selectedTab = win.gBrowser.tabContainer.childNodes[i];
					return win2;
				}
			}
		}
		return null;
	},
	openPatcher:
	function()
	{
		gBrowser.selectedTab = gBrowser.addTab("chrome://imgbot/content/patcher.xul");
	},
	openHelp:
	function()
	{
		gBrowser.selectedTab = gBrowser.addTab("http://pimpsofpain.com/imagebot.html");
	},
	onPopupShowing:
	function(e)
	{
		document.getElementById("imgbotContextMenuitem").hidden = !gContextMenu.onImage;
		document.getElementById("imgbotContextMenuitem2").hidden = !gContextMenu.hasBGImage;
	},
	uploadImage:
	function()
	{
		this.upload(gContextMenu.imageURL);
	},
	uploadBGImage:
	function()
	{
		this.upload(gContextMenu.bgImageURL);
	},
	upload:
	function(url)
	{
		function handler(win)
		{
			var nsILocalFile_file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsILocalFile);
			nsILocalFile_file.append(url.slice(url.lastIndexOf("/") + 1));
			nsILocalFile_file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
			var nsIWebBrowserPersist_persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);
			nsIWebBrowserPersist_persist.progressListener =
			{
				onStateChange:
				function(webProgress, request, stateFlags, status)
				{
					if (stateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP)
					{
						nsIWebBrowserPersist_persist.progressListener = null;
						nsILocalFile_file.initWithFile(nsILocalFile_file);
						var uc = win.frames[win.UPLOAD_CENTER];
						if (uc.loggedIn())
						{
							uc.uploadFile(nsILocalFile_file);
						}
					}
				},
				onStatusChange: function(){},
				onLocationChange: function(){},
				onProgressChange: function(){},
				onSecurityChange: function(){}
			};
			nsIWebBrowserPersist_persist.saveURI(Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(url, null, null), null , null , null , null , nsILocalFile_file);
		}
		var winst = this.getInstance();
		if (!winst)
		{
			if (Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("imgbot.overlay.open_float").getBoolPref(""))
			{
				this.openFloat(handler);
			}else{
				this.openTab(handler);
			}
		}else{
			handler(winst);
		}
	}
};
addEventListener("load",
function()
{
	removeEventListener("load", arguments.callee, false);
	document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", imgbot.onPopupShowing, false);
}, false);