var
nsIPrefBranch_upload_center,
nsIPrefBranch_template_editor,
nsIAtom_loading,
nsIAtom_done,
nsIAtom_error;
(function ()
{
	var nsIPrefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	nsIPrefBranch_upload_center = nsIPrefService.getBranch("imgbot.upload_center.");
	nsIPrefBranch_template_editor = nsIPrefService.getBranch("imgbot.template_editor.");
	var getAtom = Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService).getAtom;
	nsIAtom_loading = getAtom("loading");
	nsIAtom_done = getAtom("done");
	nsIAtom_error = getAtom("error");
})();
var
host,
host_index,
confirm_delete,
clipboard_imagename,
do_hard_delete,
////////////////
que = 0,
////////////////
multipart_boundary = new Date().getTime(),
////////////////
dropObserver =
{
	canHandleMultipleItems: true,
	onDragOver: function(){},
	onDrop:
	function(event, dropData)
	{
		if (loggedIn()){
			var initial_num_images = upload_visible_array.length + upload_hidden_array.length;
			dropData.dataList.forEach(
			function(value)
			{
				if (value.first.data.isDirectory())
				{
					uploadFiles(value.first.data.directoryEntries);
				}else{
					uploadFile(value.first.data);
				}
			});
			status_text_elt.value = locale_elt.getFormattedString("upload_center.imagesAdded", [upload_visible_array.length + upload_hidden_array.length - initial_num_images]);
		}
	},
	getSupportedFlavours:
	function()
	{
		return FlavourSet_flavors;
	}
},
FlavourSet_flavors = new FlavourSet(),
////////////////
nsIClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"].getService(Components.interfaces.nsIClipboardHelper),
nsIWindowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator),
////////////////
upload_visible_array = eval(nsIPrefBranch_upload_center.getCharPref("upload_visible_array")),
upload_hidden_array = eval(nsIPrefBranch_upload_center.getCharPref("upload_hidden_array")),
next_id = nsIPrefBranch_upload_center.getIntPref("next_id"),
////////////////
sort_index = nsIPrefBranch_upload_center.getIntPref("sort_index"),
sort_direction = nsIPrefBranch_upload_center.getIntPref("sort_direction"),
////////////////
filter,
filter_regex,
filter_type = nsIPrefBranch_upload_center.getIntPref("filter_type"),
////////////////
locale_elt = document.getElementById("locale"),
////////////////
str_loading = locale_elt.getString("upload_center.loading"),
str_done = locale_elt.getString("upload_center.done"),
str_err_type = locale_elt.getString("upload_center.errorType"),
str_err_size = locale_elt.getString("upload_center.errorSize"),
str_err_integ = locale_elt.getString("upload_center.errorIntegrity"),
str_err_dupe = locale_elt.getString("upload_center.errorDupe"),
str_err_misc = locale_elt.getString("upload_center.errorMisc"),
str_arr = [str_loading, str_done, str_err_type, str_err_size, str_err_integ, str_err_dupe, str_err_misc],
////////////////
last_sorted_treecol_elt = document.getElementsByTagName("treecol")[sort_index],
filter_elt = document.getElementById("filter"),
template_menupopup_elt = document.getElementById("template_menupopup"),
tooltip_elt = document.getElementById("upload_tree_tooltip"),
context_elt = document.getElementById("upload_tree_context"),
server_delete_elt = document.getElementById("server_delete"),
upload_tree_elt = document.getElementById("upload_tree"),
upload_treechildren_elt = document.getElementById("upload_treechildren"),
num_images_selected_elt = document.getElementById("num_images_selected"),
num_uploading_elt = document.getElementById("num_uploading"),
num_images_total_elt = document.getElementById("num_images_total"),
num_images_hidden_elt = document.getElementById("num_images_hidden"),
status_bar_elt = document.getElementById("status_bar"),
status_text_elt = document.getElementById("status_text"),
logged_in_elt = document.getElementById("logged_in"),
filter_box_elt = document.getElementById("filter_box"),
loading_trigger_elt = document.getElementById("loading_trigger"),
////////////////
nsITreeView_tree =
{
	rowCount: upload_visible_array.length,
	getCellText:
	function(row, col)
	{
		var index = col.index;
		switch (index)
		{
			case THUMB:
			return null;

			case STATUS:
			return str_arr[upload_visible_array[row][STATUS]];
			break;

			case HOST:
			return hosts[upload_visible_array[row][HOST]].name;
			break;

			default:
			return (undefined == upload_visible_array[row][index]) ? "" : upload_visible_array[row][index];
		}
		return null;
	},
	setTree:
	function(treebox){
		if (treebox)
		{
			this.treebox = treebox;
		}
	},
	cycleHeader:
	function(col)
	{
		var index = col.index;
		switch (index)
		{
			case THUMB:
			return;

			default:
			if (sort_index == index)
			{
				if (sort_direction == DESC)
				{
					col.element.setAttribute("sortDirection", "ascending");
					sort_direction = ASC;
				}else{
					col.element.setAttribute("sortDirection", "descending");
					sort_direction = DESC;
				}
			}else{
				sort_index = index;
				last_sorted_treecol_elt.removeAttribute("sortDirection");
				last_sorted_treecol_elt = col.element;
				last_sorted_treecol_elt.setAttribute("sortDirection", "ascending");
				sort_direction = ASC;
			}
			if (filter)
			{
				doFilter();
			}else{
				sortUploads();
			}
		}
	},
	getImageSrc:
	function(row, col)
	{
		switch (col.index)
		{
			case THUMB:
			return upload_visible_array[row][THUMB];

			default:
			return null;
		}
	},
	getCellProperties:
	function(row, col, props)
	{
		switch (col.index)
		{
			case STATUS:
			switch (upload_visible_array[row][STATUS])
			{
				case LOADING:
				props.AppendElement(nsIAtom_loading);
				break;

				case DONE:
				props.AppendElement(nsIAtom_done);
				break;

				case ERROR_TYPE:
				case ERROR_SIZE:
				case ERROR_INTEG:
				case ERROR_DUPE:
				case ERROR_MISC:
				props.AppendElement(nsIAtom_error);
			}
		}
	},
	canDrop: function(){return true;},
	drop: function(){},
	getParentIndex: function(){return -1;},
	isContainer: function(){return false;},
	isSeparator: function(){return false;},
	isSorted: function(){return true;},
	getLevel: function(){return 0;},
	getRowProperties: function(){},
	getColumnProperties: function(){}
};
////////////////

filter_elt.value = nsIPrefBranch_upload_center.getCharPref("filter");
document.getElementById("filter_type").value = filter_type;
FlavourSet_flavors.appendFlavour("application/x-moz-file","nsIFile");
if (sort_direction == DESC)
{
	last_sorted_treecol_elt.setAttribute("sortDirection", "descending");
}else{
	last_sorted_treecol_elt.setAttribute("sortDirection", "ascending");
}
updateFilter(false);
updateSettings();
updateTemplates();
updateCounters();
status_text_elt.value = locale_elt.getFormattedString("upload_center.initialized", [navigator.userAgent.split(" ").pop()]);
upload_tree_elt.onselect =
function()
{
	num_images_selected_elt.value = nsITreeView_tree.selection.count;
	status_text_elt.value = locale_elt.getFormattedString("upload_center.imagesSelected", [nsITreeView_tree.selection.count]);
};
logout();
host.init();
updateLoginDisplay();
upload_tree_elt.view = nsITreeView_tree;

function login()
{
	host.login();
	updateLoginDisplay();
}

function changeHost(host_idx)
{
	nsIPrefBranch_upload_center.setIntPref("host",  host_idx);
	host_index = host_idx;
	host = hosts[host_idx];
	updateLoginDisplay();
	if (parent.frames[SETTINGS].frames[0].location == "chrome://imgbot/content/functionality.xul")
	{
		parent.frames[SETTINGS].frames[0].wrappedJSObject.tabbox.selectedIndex = host_idx;
	}
}

function updateLoginDisplay()
{
	if (host.isLoggedIn())
	{
		logged_in_elt.label = locale_elt.getFormattedString("upload_center.loggedInAs", [host.getUserName(), host.name]);
		logged_in_elt.tooltipText = locale_elt.getFormattedString("upload_center.clickToLogout", []);
	}else{
		logged_in_elt.label = locale_elt.getFormattedString("upload_center.loginTo", [host.name]);
		logged_in_elt.tooltipText = locale_elt.getFormattedString("upload_center.clickToLogin", []);
	}
}

function logout()
{
	host.logout();
	updateLoginDisplay();
}

function sortUploads()
{
	upload_visible_array.sort(
	function (a, b)
	{
		if (a[sort_index] > b[sort_index])
		{
			return -sort_direction;
		}else if (a[sort_index] < b[sort_index]){
			return sort_direction;
		}else{
			return 0;
		}
	});
}

function showFilePicker()
{
	if (loggedIn())
	{
		var nsIFilePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
		nsIFilePicker.init(window, "ImageBot - " + locale_elt.getFormattedString("upload_center.selectFiles", []), Components.interfaces.nsIFilePicker.modeOpenMultiple);
		nsIFilePicker.appendFilter(locale_elt.getFormattedString("upload_center.supportedTypes", [host.name]), "*." + host.types.join("; *."));
		if (nsIFilePicker.show() == Components.interfaces.nsIFilePicker.returnOK)
		{
			var initial_num_images = upload_visible_array.length + upload_hidden_array.length;
			uploadFiles(nsIFilePicker.files);
			status_text_elt.value = locale_elt.getFormattedString("upload_center.imagesAdded", [upload_visible_array.length + upload_hidden_array.length - initial_num_images]);
		}
	}
}

function loggedIn()
{
	if (host.login_required && !host.isLoggedIn())
	{
		alert(locale_elt.getFormattedString("upload_center.requiresLogin", [host.name]));
		return false;
	}
	return true;
}

function uploadClipboard()
{
	if (loggedIn())
	{
		var nsIClipboard = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);
		var nsITransferable_trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
		nsITransferable_trans.addDataFlavor("image/jpg");
		nsIClipboard.getData(nsITransferable_trans, Components.interfaces.nsIClipboard.kGlobalClipboard);
		var out = {}, outLen = {};
		try
		{
			nsITransferable_trans.getTransferData("image/jpg", out, outLen);
		}
		catch(e)
		{
			return;
		}
		var iStream = out.value;
		iStream.QueryInterface(Components.interfaces.nsIInputStream);
		var file = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("TmpD", Components.interfaces.nsIFile);
		file.append(clipboard_imagename + ".jpg");
		file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
		var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                         .createInstance(Components.interfaces.nsIFileOutputStream);
    foStream.init(file, 0x02 | 0x08 | 0x20, 0666, 0); // write, create, truncate
    var size = iStream.available();
    var binStream = Components.classes["@mozilla.org/binaryinputstream;1"].
            createInstance(Components.interfaces.nsIBinaryInputStream);
    binStream.setInputStream(iStream);
    var boutStream = Components.classes["@mozilla.org/binaryoutputstream;1"].
            createInstance(Components.interfaces.nsIBinaryOutputStream);
    boutStream.setOutputStream(foStream);
    boutStream.writeByteArray(binStream.readByteArray(size), size);
    boutStream.close();
    foStream.close();
    binStream.close();
    iStream.close();
    file.QueryInterface(Components.interfaces.nsILocalFile);
    file.initWithFile(file);
		uploadFile(file);
	}
}

function uploadFiles(nsISimpleEnumerator_files)
{
	while (nsISimpleEnumerator_files.hasMoreElements())
	{
		var nsIFile_file = nsISimpleEnumerator_files.getNext().QueryInterface(Components.interfaces.nsIFile);
		if (nsIFile_file.isDirectory())
		{
			uploadFiles(nsIFile_file.directoryEntries);
		}else{
			uploadFile(nsIFile_file);
		}
	}
}

function uploadFile(nsIFile_file)
{
	var new_row = [null, next_id++, nsIFile_file.leafName, LOADING, nsIFile_file.fileSize, null, host_index, host.getUserName()];
	new_row.nsIFile_file = nsIFile_file;
	if (filter)
	{
		if ((filter_regex && filter.test(new_row[filter_type])) || (!filter_regex && new_row[filter_type].toString().toUpperCase().indexOf(filter) != -1))
		{
			nsITreeView_tree.treebox.rowCountChanged(upload_visible_array.length, 1);
			upload_visible_array.push(new_row);
			sortUploads();
			nsITreeView_tree.treebox.invalidate();
		}else{
			upload_hidden_array.push(new_row);
		}
	}else{
		nsITreeView_tree.treebox.rowCountChanged(upload_visible_array.length, 1);
		upload_visible_array.push(new_row);
		sortUploads();
		nsITreeView_tree.treebox.invalidate();
	}
	updateCounters();
	uploadFile2(nsIFile_file, new_row);
}

function uploadFile2(nsIFile_file, new_row)
{
	if (host.types.indexOf(nsIFile_file.leafName.split(".").pop().toLowerCase()) == -1)
	{
		new_row[STATUS] = ERROR_TYPE;
		sortAndFilter();
	}else{
		if (nsIFile_file.fileSize >= host.min_size && nsIFile_file.fileSize <= host.max_size)
		{
			var nsIFileInputStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
			nsIFileInputStream.init(nsIFile_file, 1, 1, Components.interfaces.nsIFileInputStream.CLOSE_ON_EOF);
			var nsIBufferedInputStream = Components.classes["@mozilla.org/network/buffered-input-stream;1"].createInstance(Components.interfaces.nsIBufferedInputStream);
			nsIBufferedInputStream.init(nsIFileInputStream, 4096);
			var nsIStringInputStream_start = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
			nsIStringInputStream_start.setData(host.getStreamData(nsIFile_file.leafName), -1);
			var nsIStringInputStream_end = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
			nsIStringInputStream_end.setData("\r\n" + "-----------------------------" + multipart_boundary + "--\r\n", -1);
			var nsIMultiplexInputStream = Components.classes["@mozilla.org/io/multiplex-input-stream;1"].createInstance(Components.interfaces.nsIMultiplexInputStream);
			nsIMultiplexInputStream.appendStream(nsIStringInputStream_start);
			nsIMultiplexInputStream.appendStream(nsIBufferedInputStream);
			nsIMultiplexInputStream.appendStream(nsIStringInputStream_end);
			var XMLHttpRequest_upload = new XMLHttpRequest();
			new_row.XMLHttpRequest_upload = XMLHttpRequest_upload;
			XMLHttpRequest_upload.onerror =
			{
				new_row: new_row,
				handleEvent: requestOnError
			};
			XMLHttpRequest_upload.onload =
			{
				new_row: new_row,
				handleEvent: requestOnLoad
			};
			XMLHttpRequest_upload.open("POST", host.getUploadUrl(), true);
			XMLHttpRequest_upload.setRequestHeader("Content-Type", "multipart/form-data; boundary=---------------------------" + multipart_boundary);
			updateQue(1);
			XMLHttpRequest_upload.send(nsIMultiplexInputStream);
		}else{
			new_row[STATUS] = ERROR_SIZE;
			sortAndFilter();
		}
	}
}

function requestOnError()
{
	this.new_row.XMLHttpRequest_upload = null;
	this.new_row[STATUS] = ERROR_MISC;
	sortAndFilter();
	updateQue(-1);
}

function requestOnLoad(event)
{
	this.new_row.XMLHttpRequest_upload = null;
	hosts[this.new_row[HOST]].processUpload(event.target.responseText, this.new_row);
}

function requestDone(image)
{
	if (image[STATUS] == DONE)
	{
		image.nsIFile_file = null;
	}
	sortAndFilter();
	updateQue(-1);
}

function sortAndFilter()
{
	if (filter)
	{
		doFilter();
	}
	sortUploads();
	nsITreeView_tree.treebox.invalidate();
}

function updateCounters()
{
	num_images_total_elt.value = upload_visible_array.length + upload_hidden_array.length;
	num_images_hidden_elt.value = upload_hidden_array.length;
}

function updateQue(addend)
{
	que += addend;
	num_uploading_elt.value = que;
	if (que == 0)
	{
		try
		{
			loading_trigger_elt.contentWindow.wrappedJSObject.stop();
		}catch(e){
			loading_trigger_elt.contentWindow.stop();
		}
	}else{
		try
		{
			loading_trigger_elt.contentDocument.wrappedJSObject.write();
		}catch(e){
			loading_trigger_elt.contentDocument.write();
		}
	}
}

function updateFilter(do_filter)
{
	try
	{
		var temp_filter = eval(filter_elt.value);
	}
	catch(e)
	{
		if (filter_elt.value.length){
			filter = filter_elt.value;
			status_text_elt.value = locale_elt.getFormattedString("upload_center.filterActivated", [filter]);
			filter = filter.toUpperCase();
			filter_regex = false;
			if (do_filter)
			{
				doFilter();
			}
		}else if (filter){
			clearFilter();
			filter = false;
			status_text_elt.value = locale_elt.getFormattedString("upload_center.filterDeactivated", []);
		}
		return;
	}
	if (temp_filter instanceof RegExp)
	{
		filter = temp_filter;
		filter_regex = true;
		if (do_filter)
		{
			doFilter();
		}
		status_text_elt.value = locale_elt.getFormattedString("upload_center.filterActivated", [filter]);
	}else if (filter_elt.value.length){
		filter = filter_elt.value;
		status_text_elt.value = locale_elt.getFormattedString("upload_center.filterActivated", [filter]);
		filter = filter.toUpperCase();
		filter_regex = false;
		if (do_filter)
		{
			doFilter();
		}
	}else if (filter){
		clearFilter();
		filter = false;
		status_text_elt.value = locale_elt.getFormattedString("upload_center.filterDeactivated", []);
	}
}

function doFilter()
{
	clearFilter();
	var hide_array = [];
	var hide_count = 0;
	if (filter_regex)
	{
		upload_visible_array.forEach(
		function(value, index)
		{
			if (!filter.test(value[filter_type]))
			{
				hide_array.push(index);
			}
		});
	}else{
		upload_visible_array.forEach(
		function(value, index)
		{
			if (value[filter_type].toString().toUpperCase().indexOf(filter) == -1)
			{
				hide_array.push(index);
			}
		});
	}
	nsITreeView_tree.treebox.rowCountChanged(upload_visible_array.length, -hide_array.length);
	hide_array.forEach(
	function(value)
	{
		upload_hidden_array.push(upload_visible_array.splice(value - hide_count++, 1)[0]);
	});
	nsITreeView_tree.treebox.invalidate();
	updateCounters();
}

function clearFilter()
{
	nsITreeView_tree.treebox.rowCountChanged(upload_visible_array.length, upload_hidden_array.length);
	upload_hidden_array.forEach(
	function(value)
	{
		upload_visible_array.push(value);
	});
	upload_hidden_array = [];
	sortUploads();
	nsITreeView_tree.treebox.invalidate();
	updateCounters();
}

function copySelection(index)
{
	var
	start = {},
	end = {},
	copy_array = [];
	for (var a = 0, range_count = nsITreeView_tree.selection.getRangeCount(); a < range_count; a++)
	{
		nsITreeView_tree.selection.getRangeAt(a, start, end);
		while (start.value <= end.value)
		{
			var text_to_copy = upload_visible_array[start.value][URL];
			if (text_to_copy)
			{
				copy_array.push(text_to_copy);
			}
			start.value++;
		}
	}
	nsIClipboardHelper.copyString(copy_array.join("\r\n"));
	status_text_elt.value = locale_elt.getFormattedString("upload_center.imagesCopied", [copy_array.length]);
}

function viewSelection()
{
	var
	view_count = 0,
	start = {},
	end = {},
	browserWindow = nsIWindowMediator.getMostRecentWindow("navigator:browser"),
	blankTab;
	if (!browserWindow)
	{
		open("about:blank", null, null);
		browserWindow = nsIWindowMediator.getMostRecentWindow("navigator:browser");
		blankTab = browserWindow.gBrowser.selectedTab;
	}
	for (var a = 0, range_count = nsITreeView_tree.selection.getRangeCount(); a < range_count; a++)
	{
		nsITreeView_tree.selection.getRangeAt(a, start, end);
		if (start.value <= end.value)
		{
			var url = upload_visible_array[start.value][URL];
			if (url)
			{
				browserWindow.gBrowser.selectedTab = browserWindow.gBrowser.addTab(url);
				view_count++;
			}
			start.value++;
			while (start.value <= end.value)
			{
				url = upload_visible_array[start.value][URL];
				if (url)
				{
					browserWindow.gBrowser.addTab(url);
					view_count++;
				}
				start.value++;
			}
		}
	}
	if (blankTab)
	{
		browserWindow.gBrowser.removeTab(blankTab);
	}
	status_text_elt.value = locale_elt.getFormattedString("upload_center.imagesViewed", [view_count]);
}

function copyTemplate(template)
{
	var
	func = eval("(function(){return " + template[TEMPLATE_CONTENTS] + "})"),
	start = {},
	end = {},
	copy_array = [];
	for (var a = 0, range_count = nsITreeView_tree.selection.getRangeCount(); a < range_count; a++)
	{
		nsITreeView_tree.selection.getRangeAt(a, start, end);
		while (start.value <= end.value)
		{
			var image = upload_visible_array[start.value];
			if (image[URL])
			{
				copy_array.push(func());
			}
			start.value++;
		}
	}
	nsIClipboardHelper.copyString(template[TEMPLATE_START] + copy_array.join(template[TEMPLATE_SEPARATOR]) + template[TEMPLATE_END]);
	status_text_elt.value = locale_elt.getFormattedString("upload_center.imagesCopiedWithTemplate", [copy_array.length, template[TEMPLATE_NAME]]);
}

function reUploadSelection()
{
	if (host.login_required && !host.isLoggedIn())
	{
		alert(locale_elt.getFormattedString("upload_center.requiresLogin", [host.name]));
	}else{
		var
		start = {},
		end = {};
		for (var a = 0, range_count = nsITreeView_tree.selection.getRangeCount(); a < range_count; a++)
		{
			nsITreeView_tree.selection.getRangeAt(a, start, end);
			while (start.value <= end.value)
			{
				var image = upload_visible_array[start.value];
				if (ERRORS.indexOf(image[STATUS]) != -1)
				{
					if (image.nsIFile_file.exists())
					{
						image[STATUS] = LOADING;
						image[SIZE] = image.nsIFile_file.fileSize;
						image[HOST] = host_index;
						image[USER] = host.getUserName();
						sortAndFilter();
						uploadFile2(image.nsIFile_file, image);
					}
				}
				start.value++;
			}
		}
	}
}

function deleteSelection(server_delete)
{
	if (confirm_delete ? confirm(locale_elt.getFormattedString("upload_center.confirmDelete", [nsITreeView_tree.selection.count])) : true)
	{
		var
		do_hard_delete2 = do_hard_delete || arguments.length,
		num_selected = nsITreeView_tree.selection.count,
		start = {},
		end = {};
		for (var a = 0, b, range_count = nsITreeView_tree.selection.getRangeCount(); a < range_count; a++)
		{
			nsITreeView_tree.selection.getRangeAt(0, start, end);
			var b = start.value;
			while (b <= end.value)
			{
				var img = upload_visible_array[b];
				if (img.XMLHttpRequest_upload)
				{
					img.XMLHttpRequest_upload.abort();
					img.XMLHttpRequest_upload = null;
					updateQue(-1);
				}else if (do_hard_delete2 && img[URL] && img[USER] && !hosts[img[HOST]].deleteImage(img)){
					b++;
					continue;
				}
				nsITreeView_tree.treebox.rowCountChanged(b, -1);
				upload_visible_array.splice(b, 1);
				end.value--;
			}
		}
		updateCounters();
		status_text_elt.value = locale_elt.getFormattedString("upload_center.imagesDeleted", [num_selected - nsITreeView_tree.selection.count]);
	}
}

function selectAll()
{
	nsITreeView_tree.selection.rangedSelect(0, upload_visible_array.length - 1, true);
}

function updateSettings()
{
	var at1, at2;
	if (nsIPrefBranch_upload_center.getBoolPref("expert_mode"))
	{
		at1 = "tooltiptext";
		at2 = "_tooltiptext";
	}else{
		at1 = "_tooltiptext";
		at2 = "tooltiptext";
	}
	var elt_array = document.getElementsByTagName("*");
	for (var i = 0; i < elt_array.length; i++)
	{
		var elt = elt_array[i];
		if (elt.hasAttribute(at1))
		{
			elt.setAttribute(at2, elt.getAttribute(at1));
		}
		elt.removeAttribute(at1);
	}
	filter_box_elt.setAttribute("collapsed", nsIPrefBranch_upload_center.getBoolPref("hide_filter"));
	status_bar_elt.setAttribute("collapsed", nsIPrefBranch_upload_center.getBoolPref("hide_status_bar"));
	if (nsIPrefBranch_upload_center.getBoolPref("hide_context"))
	{
		context_elt.hidePopup();
		upload_treechildren_elt.contextMenu = null;
	}else{
		upload_treechildren_elt.contextMenu = "upload_tree_context";
	}
	if (nsIPrefBranch_upload_center.getBoolPref("hide_popup"))
	{
		tooltip_elt.hidePopup();
		upload_treechildren_elt.tooltip = null;
	}else{
		upload_treechildren_elt.tooltip = "upload_tree_tooltip";
	}
	do_hard_delete = nsIPrefBranch_upload_center.getBoolPref("do_hard_delete");
	server_delete_elt.setAttribute("collapsed", do_hard_delete);
	confirm_delete = nsIPrefBranch_upload_center.getBoolPref("confirm_delete");
	host_index = nsIPrefBranch_upload_center.getIntPref("host");
	clipboard_imagename = nsIPrefBranch_upload_center.getCharPref("clipboard_imagename");
	host = hosts[host_index];
	host.prefs.forEach(
	function(pref)
	{
		var
		pref_val,
		full_pref = "host" + host_index + "." + pref;
		switch (nsIPrefBranch_upload_center.getPrefType(full_pref))
		{
			case Components.interfaces.nsIPrefBranch.PREF_STRING:
			pref_val = nsIPrefBranch_upload_center.getCharPref(full_pref);
			break;

			case Components.interfaces.nsIPrefBranch.PREF_INT:
			pref_val = nsIPrefBranch_upload_center.getIntPref(full_pref);
			break;

			case Components.interfaces.nsIPrefBranch.PREF_BOOL:
			pref_val = nsIPrefBranch_upload_center.getBoolPref(full_pref);
		}
		host[pref] = pref_val;
	});
	updateLoginDisplay();
	setTimeout(function(){document.styleSheets[1].cssRules[0].style.height = nsIPrefBranch_upload_center.getCharPref("row_height");}, 1);
}

function updateTemplates()
{
	while (template_menupopup_elt.hasChildNodes())
	{
		template_menupopup_elt.removeChild(template_menupopup_elt.firstChild);
	}
	eval(nsIPrefBranch_template_editor.getCharPref("template_array")).forEach(
	function(value)
	{
		var menuitem = document.createElement("menuitem");
		menuitem.setAttribute("label", value[0]);
		menuitem.setAttribute("oncommand", "copyTemplate(" + value.toSource() + ")");
		template_menupopup_elt.appendChild(menuitem);
	});
}

function removeCookies(host)
{
	var manager = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager);
	var enumerator = manager.enumerator;
	while (enumerator.hasMoreElements())
	{
		var cookie = enumerator.getNext().QueryInterface(Components.interfaces.nsICookie);
		if (cookie.host == host)
		{
			manager.remove(cookie.host, cookie.name, cookie.path, false);
		}
	}
}

function addExternalImage(name, img, thumb, size, host, user)
{
	for (var i = 0; i < upload_visible_array.length; i++)
	{
		if (upload_visible_array[i][URL] == img)
		{
			return;
		}
	}
	for (i = 0; i < upload_hidden_array.length; i++)
	{
		if (upload_hidden_array[i][URL] == img)
		{
			return;
		}
	}
	var new_row = [thumb, next_id++, name, DONE, size, img, host, user];
	if (filter)
	{
		if ((filter_regex && filter.test(new_row[filter_type])) || (!filter_regex && new_row[filter_type].toString().toUpperCase().indexOf(filter) != -1))
		{
			nsITreeView_tree.treebox.rowCountChanged(upload_visible_array.length, 1);
			upload_visible_array.push(new_row);
			sortUploads();
			nsITreeView_tree.treebox.invalidate();
		}else{
			upload_hidden_array.push(new_row);
		}
	}else{
		nsITreeView_tree.treebox.rowCountChanged(upload_visible_array.length, 1);
		upload_visible_array.push(new_row);
		sortUploads();
		nsITreeView_tree.treebox.invalidate();
	}
}

function onunload()
{
	var
	remove_array = [],
	remove_count = 0;
	upload_visible_array.forEach(
	function(value, index)
	{
		if (value[STATUS] != DONE)
		{
			remove_array.push(index);
		}
	});
	remove_array.forEach(
	function(value)
	{
		upload_visible_array.splice(value - remove_count++, 1);
	});
	remove_array = [];
	remove_count = 0;
	upload_hidden_array.forEach(
	function(value, index)
	{
		if (value[STATUS] != DONE)
		{
			remove_array.push(index);
		}
	});
	remove_array.forEach(
	function(value)
	{
		upload_hidden_array.splice(value - remove_count++, 1);
	});
	nsIPrefBranch_upload_center.setCharPref("upload_visible_array", upload_visible_array.toSource());
	nsIPrefBranch_upload_center.setCharPref("upload_hidden_array", upload_hidden_array.toSource());
	nsIPrefBranch_upload_center.setIntPref("next_id", next_id);
	nsIPrefBranch_upload_center.setIntPref("filter_type", filter_type);
	nsIPrefBranch_upload_center.setCharPref("filter", filter_elt.value);
	nsIPrefBranch_upload_center.setIntPref("sort_index", sort_index);
	nsIPrefBranch_upload_center.setIntPref("sort_direction", sort_direction);
}